package hk.quantr.javalib.swing.advancedswing.imageviewer;

import hk.quantr.javalib.CommonLib;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class ImageViewerDialog extends javax.swing.JDialog {

	BufferedImage image;
	float ratio = 1.0f;

	/**
	 * Creates new form ImageViewerDialog
	 */
	public ImageViewerDialog(java.awt.Frame parent, boolean modal, BufferedImage image) {
		super(parent, modal);
		initComponents();

		this.image = image;
		highDPIJLabel1.setIcon(new ImageIcon(image));
		highDPIJLabel1.addDrag(jScrollPane1);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        highDPIJLabel1 = new hk.quantr.javalib.swing.advancedswing.highdpijlabel.HighDPIJLabel();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        zoomInButton = new javax.swing.JButton();
        zoomOutButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jScrollPane1.setViewportView(highDPIJLabel1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jButton1.setText("1:1");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        zoomInButton.setText("Zoom In");
        zoomInButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomInButtonActionPerformed(evt);
            }
        });
        jPanel1.add(zoomInButton);

        zoomOutButton.setText("Zoom Out");
        zoomOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomOutButtonActionPerformed(evt);
            }
        });
        jPanel1.add(zoomOutButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_START);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		highDPIJLabel1.ratio = 1.0f;
		highDPIJLabel1.repaint();
//		highDPIJLabel1.setIcon(new ImageIcon(image));
    }//GEN-LAST:event_jButton1ActionPerformed

    private void zoomInButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomInButtonActionPerformed
		highDPIJLabel1.ratio += 0.1;
		highDPIJLabel1.repaint();
//		BufferedImage temp = CommonLib.resizeImageByHeight(image, (int) (image.getHeight() * ratio), BufferedImage.TYPE_INT_ARGB);
//		highDPIJLabel1.setIcon(new ImageIcon(temp));
    }//GEN-LAST:event_zoomInButtonActionPerformed

    private void zoomOutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomOutButtonActionPerformed
		highDPIJLabel1.ratio -= 0.1;
		if (highDPIJLabel1.ratio < 0.1) {
			highDPIJLabel1.ratio = 0.1f;
		}
		highDPIJLabel1.repaint();
//		BufferedImage temp = CommonLib.resizeImageByHeight(image, (int) (image.getHeight() * ratio), BufferedImage.TYPE_INT_ARGB);
//		System.out.println(temp.getWidth());
//		highDPIJLabel1.setIcon(new ImageIcon(temp));
    }//GEN-LAST:event_zoomOutButtonActionPerformed

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Create and display the dialog */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BufferedImage image = CommonLib.toBufferedImage(new URL("https://www.quantr.foundation/wp-content/uploads/2023/08/Screenshot-2023-08-28-at-12.21.13-AM.png"));
					ImageViewerDialog dialog = new ImageViewerDialog(new javax.swing.JFrame(), true, image);
					dialog.addWindowListener(new java.awt.event.WindowAdapter() {
						@Override
						public void windowClosing(java.awt.event.WindowEvent e) {
							System.exit(0);
						}
					});
					dialog.setSize(900, 700);
					dialog.setLocationRelativeTo(null);
					dialog.setVisible(true);
				} catch (MalformedURLException ex) {
					Logger.getLogger(ImageViewerDialog.class.getName()).log(Level.SEVERE, null, ex);
				} catch (IOException ex) {
					Logger.getLogger(ImageViewerDialog.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private hk.quantr.javalib.swing.advancedswing.highdpijlabel.HighDPIJLabel highDPIJLabel1;
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton zoomInButton;
    private javax.swing.JButton zoomOutButton;
    // End of variables declaration//GEN-END:variables
}
